﻿<UserControl x:Class="HiVE.BasicModels.MaskedTextBoxs.MaskedTextBox"
             xmlns="http://schemas.microsoft.com/winfx/2006/xaml/presentation"
             xmlns:x="http://schemas.microsoft.com/winfx/2006/xaml"
             xmlns:mc="http://schemas.openxmlformats.org/markup-compatibility/2006" 
             xmlns:d="http://schemas.microsoft.com/expression/blend/2008" 
             xmlns:local="clr-namespace:HiVE.BasicModels.MaskedTextBoxs"
             mc:Ignorable="d"
             x:Name="maskedTextBoxUC"             
             d:DesignHeight="32" d:DesignWidth="200"
             MinHeight="32"
             MinWidth="85"
             DataContext="{Binding RelativeSource={RelativeSource Self}}"
             Loaded="maskedTextBoxUC_Loaded">

    <UserControl.Resources>
        <local:Converter_TextInputToVisibility x:Key="Converter_TextInputToVisibility"/>

        <BooleanToVisibilityConverter x:Key="BooleanToVisibilityConverter" />

        <Style x:Key="MaskedTextBox_TextBox" x:Name="MaskedTextBox_TextBox" TargetType="{x:Type TextBox}">
            <Setter Property="HorizontalAlignment" Value="Stretch"/>
            <Setter Property="VerticalAlignment" Value="Center"/>
            <Setter Property="HorizontalContentAlignment" Value="Center"/>
            <Setter Property="VerticalContentAlignment" Value="Center"/>
            <Setter Property="Margin" Value="1"/>
            <Setter Property="Padding" Value="2"/>
            <Setter Property="TextWrapping" Value="Wrap"/>
            <Setter Property="Foreground" Value="#FF2D3E52"/>
        </Style>

        <SolidColorBrush x:Key="MaskedTextBox_BrushWatermarkBackground" Color="Transparent" />
        <SolidColorBrush x:Key="MaskedTextBox_BrushWatermarkForeground" Color="#FF808080" />
        <SolidColorBrush x:Key="MaskedTextBox_BrushWatermarkBorder" Color="#FFD2D7D3" />

        <Style x:Key="MaskedTextBox_EntryFieldStyle" x:Name="MaskedTextBox_EntryFieldStyle" TargetType="Grid" >
            <Setter Property="HorizontalAlignment" Value="Center" />
            <Setter Property="VerticalAlignment" Value="Center" />
            <Setter Property="Margin" Value="1" />
        </Style>
    </UserControl.Resources>

    <Border HorizontalAlignment="Stretch"
            VerticalAlignment="Stretch"
            Padding="1"
            Background="Transparent">
        <Grid HorizontalAlignment="Stretch"
              VerticalAlignment="Center"
              Background="{StaticResource MaskedTextBox_BrushWatermarkBackground}"
              Style="{StaticResource MaskedTextBox_EntryFieldStyle}">

            <!--Visibility="{Binding ElementName=textBoxValue, Path=Text.IsEmpty, Converter={StaticResource BooleanToVisibility}}"-->
            <TextBlock Name="textBoxWatermark"
                       Margin="2,2"
                       Padding="2,4"
                       Foreground="{StaticResource MaskedTextBox_BrushWatermarkForeground}"
                       HorizontalAlignment="Stretch"
                       VerticalAlignment="Center"
                       TextAlignment="Left"
                       Text="{Binding ElementName=maskedTextBoxUC, Path=Watermark}"
                       FontWeight="Medium">
                <TextBlock.Visibility>
                    <MultiBinding Converter="{StaticResource Converter_TextInputToVisibility}">
                        <Binding ElementName="textBoxValue" Path="Text.IsEmpty" />
                        <Binding ElementName="textBoxValue" Path="IsFocused" />
                    </MultiBinding>
                </TextBlock.Visibility>
            </TextBlock>

            <TextBox Name="textBoxValue"
                     Margin="2,2"
                     Padding="0,4"
                     Background="Transparent"
                     BorderBrush="{StaticResource MaskedTextBox_BrushWatermarkBorder}"
                     Style="{StaticResource MaskedTextBox_TextBox}"
                     BorderThickness="0,0,0,2"
                     FontWeight="Medium"
                     Focusable="True"
                     TextAlignment="Left"
                     Text="{Binding ElementName=maskedTextBoxUC, Path=Text, Mode=TwoWay}"
                     PreviewKeyDown="textBoxValue_PreviewKeyDown"
                     PreviewTextInput="textBoxValue_PreviewTextInput"
                     TextChanged="textBoxValue_TextChanged"/>
        </Grid>
    </Border>
</UserControl>
